Index: /documentation/trunk/tutorials/xml-source/tutorial_en.xml
===================================================================
--- /documentation/trunk/tutorials/xml-source/tutorial_en.xml	(revision 30204)
+++ /documentation/trunk/tutorials/xml-source/tutorial_en.xml	(revision 30205)
@@ -778,33 +778,84 @@
 </NumberedItem>
 <NumberedItem>
-<Text id="images-gps-1a">Since the images are organised by folder, we can easily assign <i>folder-level</i> metadata to the images which will help with classifying them. In the <b>Enrich</b> panel, select the eiffel-tower folder, and in its <b>dc.Title</b> field type <i>Eiffel Tower</i>. Since this metadata is assigned at folder level, it is inherited as <b>dc.Title</b> metadata by all the images in the folder. Now select each of the remaining folders in turn, and assign the appropriate values for their <b>dc.Title</b>: <i>MusÃ©e d'Orsay</i>, <i>Parc de Luxembourg</i> and <i>PanthÃ©on district</i>, respectively.</Text>
-</NumberedItem>
-<NumberedItem>
-<Text id="images-gps-2">In the <b>Document Plugins</b> section of the <b>Design</b> panel, go down to the <b>select plugin to add</b> and choose the <b>EmbeddedMetadataPlugin</b>. Press the <b>Add Plugin</b> button, and then click <b>OK</b> to add it to the plugin list. Select this plugin in the list, then use the <b>Move Up</b> button to shift it upwards until it comes just after the GreenstoneXMLPlugin.</Text>
-</NumberedItem>
-<NumberedItem>
-<Text id="images-gps-3">Now go to the <b>Create</b> panel and press <b>Build Collection</b>.</Text>
-</NumberedItem>
-<NumberedItem>
-<Text id="images-gps-4">Preview the collection and click the <b>Titles</b> tab. This is what an image collection looks like by default. However, these images have embedded GPS metadata, and we can use this extracted GPS metadata to display these images more meaningfully. In the <b>Enrich</b> panel, expand the <b>eiffel-tower</b> folder and select the first image. Scroll down to see the metadata extracted during the building process. Among the extracted metadta, you will find several pieces of Latitude and Longitude metadata, which we will be taking advantage of: ex.LatShort, ex.Latitude, ex.LngShort and ex.Longitude. Greenstone has a map view that can make use of this location metadata to present the images.</Text>
-</NumberedItem>
-<NumberedItem>
-<Text id="images-gps-6">In the <b>Search Indexes</b> section of the <b>Design</b> panel, press the <b>New Index...</b> button. Scroll down and tick the boxes for <b>ex.LatShort</b>, <b>ex.Latitude</b>, <b>ex.LngShort</b> and <b>ex.Longitude</b> and press <b>Add Index</b> to create an index on all these 4 pieces of metadata.</Text> 
-</NumberedItem>
-<NumberedItem>
-<Text id="images-gps-7">In the <b>Browsing Classifiers</b> section, choose <b>AZCompactList</b> from the <b>select classifier to add</b> dropdown box and press <b>Add Classifier...</b>. In the configuration dialog that appears, set the metadata field to <b>dc.Title</b> and set the buttonname field to <Format>location</Format>. This will create a classifier labelled <Format>location</Format> that groups all images under Eiffel Tower into one bookshelf and similarly creates bookshelves for the other 3 categories.</Text> 
-</NumberedItem>
-<NumberedItem>
-<Text id="images-gps-8">To enable the map, go to the <b>Format Features</b> section of the <b>Format</b> panel, and select the <b>browse</b> format feature. In the editor below, enter the following format statement <i>above</i> the documentNode template:</Text>
+  <Text id="images-gps-1a">Since the images are organised by folder, we can easily assign <i>folder-level</i> metadata to the images which will help with classifying them. In the <b>Enrich</b> panel, select the <Path>eiffel-tower</Path> folder, and in its <b>dc.Title</b> field type <i>Eiffel Tower</i>. Since this metadata is assigned at folder level, it is inherited as <b>dc.Title</b> metadata by all the images in the folder.</Text>
+  <Text id="images-gps-1b">When setting folder-level metadata like this, the default setting in GLI is to produce a popup window alerting you to the fact that the assigned metadata will be assigned
+  to all files and sub-folders contained in the selected folder.  For this collection, this is what we want, so press <i>OK</i> for the action to proceed.</Text>
+  <Text id="images-gps-1c">Note: if you prefer this popup not to appear each time you assign folder-level metadata, there is a tick-box in the lower left-hand corner of the popup window (&quot;do not show this warning again&quot;) that allows you to control this.  If you choose to supress the popup, then it can be turned back on through <Path>File &rarr; Preferences</Path> and then clicking on the <i>Warnings</i> tab.  The various options are alphabetically sorted, with the option that controls this popup: &quot;About to add folder level metadata&quot;.</Text>
+</NumberedItem>
+<NumberedItem>  
+  <Text id="images-gps-2">Now select each of the remaining folders of images in turn, and assign the appropriate values for their <b>dc.Title</b>: <i>MusÃ©e d'Orsay</i>, <i>Parc de Luxembourg</i> and <i>PanthÃ©on district</i>, respectively.</Text>
+</NumberedItem>
+<NumberedItem>
+<Text id="images-gps-3">In the <b>Browsing Classifiers</b> section, choose <b>AZCompactList</b> from the <b>select classifier to add</b> dropdown box and press <b>Add Classifier...</b>. In the configuration dialog that appears, set the metadata field to <b>dc.Title</b> and set the buttonname field to <Format>location</Format>. This will create a classifier labelled <Format>location</Format> that groups all images under Eiffel Tower into one bookshelf and similarly creates bookshelves for the other 3 categories.</Text> 
+</NumberedItem>
+<NumberedItem>
+<Text id="images-gps-4">Now go to the <b>Create</b> panel and press <b>Build Collection</b>.</Text>
+</NumberedItem>
+<NumberedItem>
+<Text id="images-gps-5">Preview the collection and click the <b>Locations</b> tab in the web browser. Expand the bookshelf icons displayed in the web browser to see thumbnail pictures of the photos gathered under the displayed metadata heading. Explore further, and click on a thumbnail photos or two to view larger versions of the photos in the document view.</Text>
+</NumberedItem>
+
+<Heading>
+<Text id="0350gpsa">Extracting embedded metadata</Text>
+</Heading>
+<NumberedItem>
+  <Text id="images-gps-6">
+  Each of these image files has metadata embedded in it&mdash;including GPS data&mdash;generated by the smartphone when the photo was taken. We can extract this metadata when the collection is built, and in particular, make use of the GPS metadata to provide map-based views of the collection to the user.</Text>
+
+  <Text id="images-gps7">In the <b>Document Plugins</b> section of the <b>Design</b> panel, go down to the <b>select plugin to add</b> and choose the <b>EmbeddedMetadataPlugin</b>. Press the <b>Add Plugin</b> button, and then click <b>OK</b> to add it to the plugin list. Select this plugin in the list, then use the <b>Move Up</b> button to shift it upwards until it comes just after the GreenstoneXMLPlugin.</Text>
+</NumberedItem>
+
+<NumberedItem>
+<Text id="images-gps-8">Go to the <b>Create</b> panel and press <b>Build Collection</b>.</Text>
+</NumberedItem>
+
+<NumberedItem>
+  <Text id="images-gps-9">Now go to the <b>Enrich</b> panel, expand the <b>eiffel-tower</b> folder and select the first image. Scroll down to see the metadata extracted during the building process. Among the extracted metadta, you will find several pieces of Latitude and Longitude metadata, which we will be taking advantage of shortly: ex.Latitude, ex.Longitude, ex.LatShort, and ex.LngShort.  </Text>
+</NumberedItem>
+  
+<Heading>
+<Text id="0350gpsb">Adding in a map view to browsing</Text>
+</Heading>
+<Text id="image-gps-10">
+  Greenstone has a map view, based on the Google Maps API, that can make use of this location metadata.  The map view can be controlled to appear in different parts of the interface: as part of a collection's search results page when browsing the collection, and/or when viewing a document.  For this view to be operational in a Grenstone, it is necessary for the collection to index the GPS metadata.</Text>
+<NumberedItem>
+<Text id="images-gps-11">In the <b>Search Indexes</b> section of the <b>Design</b> panel, press the <b>New Index...</b> button. Scroll down and tick the boxes for <b>ex.LatShort</b>, <b>ex.Latitude</b>, <b>ex.LngShort</b> and <b>ex.Longitude</b> and press <b>Add Index</b> to create an index on all these 4 pieces of metadata.</Text> 
+</NumberedItem>
+<NumberedItem>
+<Text id="images-gps-12">Select <b>Search</b> on the right of the <b>Format</b> panel. For the index on the combined longitude and latitude metadata, type <i>location</i> as its display name.</Text>
+</NumberedItem>
+<NumberedItem>
+<Text id="images-gps-13">Now go to the <b>Create</b> panel and press <b>Build Collection</b>.</Text>
+</NumberedItem>
+<NumberedItem>
+<Text id="images-gps-14">To enable the map, go to the <b>Format Features</b> section of the <b>Format</b> panel, and select the <b>browse</b> format feature. In the editor below, enter the following format statement <i>above</i> the documentNode template:</Text>
 <Format>&lt;gsf:option name="mapEnabled" value="true" /&gt;</Format> 
 </NumberedItem>
 <NumberedItem>
-<Text id="images-gps-9">Select <b>Search</b> on the right of the <b>Format</b> panel. For the index on the combined longitude and latitude metadata, type <i>location</i> as its display name.</Text>
-</NumberedItem>
-<NumberedItem>
-<Text id="images-gps-10">Go to the <b>Create</b> panel and rebuild the collection. Once rebuilt, press the <b>Preview Collection</b> button, and click on the new browsing classifier. The page that opens up shows a Google map, with the locations of the images in the collection pinpointed on it. The map view can also scroll through all the images, locating each place and associated image in turn.</Text> 
-</NumberedItem>
+<Text id="images-gps-15">In the <b>Format</b> panel press the <b>Preview Collection</b> button, and click on the new browsing classifier. The page that opens up shows a Google map, with the locations of the images in the collection pinpointed on it. The map view can also scroll through all the images, locating each place and associated image in turn.</Text> 
+</NumberedItem>
+<Text id="images-gps-16">
+  By adding the <Format>&lt;gsf:option name="mapEnabled" value="true" /&gt;</Format> statement
+  to the <b>browser</b> format feature, all of the classifiers built will have the map
+  view enabled.  It is also possible to activiate the map view on individual classifiers,
+  and on the search results page by adding the <i>mapEnabled</i> statement to the <i>search</i>
+  format feature.
+</Text>
+
+<Heading>
+<Text id="0350gpsc">Adding in a map view to a document</Text>
+</Heading>
+  <NumberedItem>
+    <Text id="images-gps-17">
+      To activate a map view when viewing the document, go to the <b>Format Features</b> section of the <b>Format</b> panel, and select the <b>display</b> format feature. In the editor below, enter the following format statement <i>above</i> the documentNode template:
+    <Format>&lt;gsf:option name="mapEnabled" value="true" /&gt;</Format>
+    </Text>
+  </NumberedItem>
+  <NumberedItem>
+    <Text id="images-gps-18">Still in the <b>Format</b> panel press the <b>Preview Collection</b> button, browsing or search to locate a document, and then view the document. The page that opens up shows a Google map, shows the location of document (where the photo was taken), in addition to the screen-sized photo.</Text>
+  </NumberedItem>  
 </Content>
-</Tutorial>
+</Tutorial
+>
 </MajorVersion>
 <Tutorial id="word_pdf_collection">