Index: /main/trunk/gli/classes/dictionary_gu.properties
===================================================================
--- /main/trunk/gli/classes/dictionary_gu.properties	(revision 30227)
+++ /main/trunk/gli/classes/dictionary_gu.properties	(revision 30228)
@@ -585,4 +585,11 @@
 ExportAsPrompt.Failed_Title:àªàªà«àª·à«àªªà«àª°à«àª àªªà«àª°àªà«àª°àª¿àª¯àªŸ àªšàª¿àª·à«àª«àª³ àªàª
 ExportAsPrompt.Instructions:àªžàªàªà«àª°àª¹àª®àªŸàª àª¬à«àªàªŸ àª«à«àª°à«àª®à«àªàª®àªŸàª àª«àªŸàªàª²à«àªšà« àªàªà«àª·à«àªªà«àª°à«àª àªàª°à«.
+ExportAsPrompt.Progress_Label:àª«àªŸàªàª²à« àªàªà«àª·à«àªªà«àª°à«àª àª¥àª àª°àª¹à« àªà«. àª àªªà«àª°àªà«àª°àª¿àª¯àªŸ àª¥à«àª¡à« àªžàª®àª¯ àª²à«àª¶à«âŠ
+ExportAsPrompt.Successful_ExportOne:{0} àªžàªàªà«àª°àª¹ àªàªà«àª·à«àªªà«àª°à«àª àª¥àª àªà«àªà«àª¯à«àª.
+ExportAsPrompt.Successful_Details:{1} àª®àªŸàªÂ àª«àªŸàªàª²à« àªàªà«àª·à«àªªà«àª°à«àª àª¥àª àªàª
+ExportAsPrompt.Successful_Title:àªàªà«àª·à«àªªà«àª°à«àª àªªà«àª°à«àª£
+ExportAsPrompt.Title:àªžàªàªà«àª°àª¹àªšà« àªàªà«àª·à«àªªà«àª°à«àª àªàª°à«
+ExportAsPrompt.SaveAs:àª®àªŸàª àªàªà«àª·à«àªªà«àª°à«àª
+ExportAsPrompt.SaveAs_Tooltip:àªà« àª«à«àª°à«àª®à«àªàª®àªŸàª àªàªà«àª·à«àªªà«àª°à«àª àªàª°àªµàªŸàªšà« àª¹à«àª¯ àª€à« àª«à«àª°à«àª®à«àª àªªàªžàªàªŠ àªàª°à«
 ExportAsPrompt.Cancel:àª°àªŠ àªàª°à«
 ExportAsPrompt.Cancel_Tooltip:àªàªà«àª·à«àªªà«àª°à«àª àª¥àªµàªŸàªšà« àªªà«àª°àªà«àª°àª¿àª¯àªŸ àª°àªŠ àªàª°à«
@@ -591,8 +598,55 @@
 ExportAsPrompt.ApplyXSL:XSL àª«àªŸàªàª²Â {0}àªšà« àª²àªŸàªà«
 ExportAsPrompt.ApplyXSL_Tooltip:àªàªà«àª·à«àªªà«àª°à«àª àªàª°à«àª² àª«àªŸàªàª²à«àªšà« àª°à«àªªàªŸàªàª€àª° àªàª°àªµàªŸ àª®àªŸàªà« xsl àª«àªŸàªàª²àªšà« àªàªªàª¯à«àª àªàª°à«.
+ExportAsPrompt.MARCXMLGroup:marc àª°à«àªàª°à«àª¡àªžàªšà« àªà«àªªàª®àªŸàª àª°àªŸàªà«
+ExportAsPrompt.MARCXMLGroup_Tooltip:àª®àªŸàª€à«àª° àªàª àª àª«àªŸàªàª²àª®àªŸàª àª€àª®àªŸàª® marc àª°à«àªàª°à«àª¡àªžàªšà« àªàªà«àª·à«àªªà«àª°à«àª àªàª°à«.
+ExportAsPrompt.MappingXML:Â àª®à«àªªà«àªàª àª«àªŸàªàª² àª²àªŸàªà« àªªàªŸàª¡à«
+ExportAsPrompt.MappingXML_Tooltip:àªàªà«àª·à«àªªà«àª°à«àªà«àª¡ àª«àªŸàªàª²à«àªšà« àªàªšà«àªµàª°à«àª àªàª°àªµàªŸ àª®à«àªªà«àªàª àª«àªŸàªàª²àªšà« àªàªªàª¯à«àª àªàª°à«.
 #
 #***** Inherited Metadata *****
+ExtractedMetadata.Message:àªªàªžàªàªŠ àªàª°à«àª² àª«àªŸàªàª² àª
+àª¥àªµàªŸ àª«à«àª²à«àª¡àª° àªàªà«àª·àªà«àª°à«àªàªà«àª¡ àª®à«àªàªŸàª¡à«àªàªŸ àª§àª°àªŸàªµà« àªà«, àªªàª°àªàª€à« àª€à« àª¹àªŸàª²àª®àªŸàª àªà«àªªà«àª€ àªà«. àªàªà«àª·àªà«àª°à«àªàªà«àª¡ àª®à«àªàªŸàª¡à«àªàªŸ àªà«àªµàªŸ àª®àªŸàªà« "àª«àªŸàªàª²" àª®à«àªšà«àª®àªŸàª àªàªŸàªµ àª
+àªšà« "àªªà«àª°à«àª«à«àª°à«àªšà«àªžà«àª" àªªàªžàªàªŠ àªàª°à«. "àªàªšàª°àª²" àªªà«àª°à«àªªàª°à«àªà«àª àª¶à«àªàª®àªŸàª "àªàªà«àª·àªà«àª°à«àªàªà«àª¡ àª®à«àªàªŸàª¡à«àªàªŸ àªà«àª" àªªàªžàªàªŠ àªàª°à«, àªªàªà« "àª¬àª§à«àª àª¬àª°àªŸàª¬àª°" àª¬àªàªš àªŠàª¬àªŸàªµà«.
+ExtractedMetadata.Title:àª àª«àªŸàªàª²/àª«à«àª²à«àª¡àª°à« àªàªà«àª·àªà«àª°à«àªàªà«àª¡ àª®à«àªàªŸàª¡à«àªàªŸàªšà« àªà«àªªà«àª€ àª°àªŸàªà«àª¯àªŸ àªà«
 #
 #***** FileActions *****
+FileActions.Calculating_Size:àªªàªžàªàªŠ àªàª°à«àª² àª«àªŸàªàª²à«àªšà« àªà«àª² àªàªŠàªšà« àªàª£àª€àª°à« àª¥àª àª°àª¹à« àªà«
+FileActions.ChooseDestinationDirectory:àª¡à«àªžà«àªà«àªšà«àª¶àªš àª¡à«àª°à«àªà«àªàª°à« àªªàªžàªàªŠ àªàª°à«
+FileActions.Copying:{0} àªà«àªªà« àª¥àª àª°àª¹à« àªà«
+FileActions.Could_Not_Delete:{0} àª°àªŠ àª¥àª àª¶àªà« àªšàª¹àª¿
+FileActions.Cyclic_Path:{0} àªà«àªªà« àªàª°à« àª¶àªàªŸàª¶à« àªšàª¹àª¿: àª¡à«àªžà«àªà«àªšà«àª¶àªš àª«à«àª²à«àª¡àª°àª àªžà«àª°à«àªž àª«à«àª²à«àª¡àª°àªšà«àª àªªà«àªàªŸàª«à«àª²à«àª¡àª° àªà«.
+FileActions.Deleting:{0} àª°àªŠ àª¥àª àª°àª¹à« àªà«
+FileActions.Directories_Selected:{0} àª«à«àª²à«àª¡àª°à«àªž àªªàªžàªàªŠ àªàª°à«àª¯àªŸ
+FileActions.Directory_Selected:1 àª«à«àª²à«àª¡àª° àªªàªžàªàªŠ àªàª°à«àª¯à«àª
+FileActions.File_Already_Exists_No_Create:'{0}' àª«àªŸàªàª² àª
+àªžà«àª€àª¿àª€à«àªµàª®àªŸàª àªà«.
+FileActions.File_And_Directories_Selected:1 àª«àªŸàªàª² àª
+àªšà« {0} àª«à«àª²à«àª¡àª°à«àªž àªªàªžàªàªŠ àªàª°à«àª¯àªŸ
+FileActions.File_And_Directory_Selected:1 àª«àªŸàªàª² àª
+àªšà« 1 àª«à«àª²à«àª¡àª° àªªàªžàªàªŠ àªàª°à«àª¯à«àª
+FileActions.File_Create_Error:{0} àª«àªŸàªàª² àª€à«àª¯àªŸàª° àªàª°à« àª¶àªà«àª¯àªŸ àªšàª¹àª¿.
+FileActions.Folder_Create_Error:{0} àª«à«àª²à«àª¡àª° àª€à«àª¯àªŸàª° àªàª°à« àª¶àªàªŸàª¶à« àªšàª¹àª¿.
+FileActions.Folder_Does_Not_Exist:àª àª«à«àª²à«àª¡àª° àª
+àªžà«àª€àª¿àª€à«àªµàª®àªŸàª àªšàª¥à«, àªàªŸàªàª€à« àª€à« àª«à«àª²à«àª¡àª°àªšà«àª àªšàªŸàª® àª¬àªŠàª²àªŸàª¯ àªàª¯à«àª àªà« àª
+àª¥àªµàªŸ àª°àªŠ àª¥àª àªàª¯à«àª àªà«
+FileActions.File_Exists:{0}àª àª¡à«àªžà«àªà«àªšà«àª¶àªš àª«à«àª²à«àª¡àª°àª®àªŸàª àªà«àª¯àªŸàª°àªšà«àª àª
+àªžà«àª€àª¿àª€à«àªµàª®àªŸàª àªà«. àª€à« àªàªµàª°àª°àªŸàªàª àªàª°àªµà«àª àªà«?
+FileActions.File_Move_Error_Message:àªàª àªàªà«àª¯àªŸàª àª¥à« àª¬à«àªà« àªàªà«àª¯àªŸàª àªàªžàª¶à« àªšàª¹àª¿ {0} to\n{1}.
+FileActions.File_Not_Deleted_Message:{0}\n àªšàªŸàª®àªšà« àªàªªàª° àª®à«àªàª¬àªšà« àª«àªŸàªàª² àª°àªŠ àª¥àª àª¶àªà« àªšàª¹àª¿. \n àªàªŸàª€àª°à« àªàª°à« àªà« àª àª«àªŸàªàª² àªà«àª²à« àªš àª¹à«àª¯. \n àªàªà«àª·àªàª°à«àªšàª² àªªà«àª°à«àªà«àª°àªŸàª®àª®àªŸàª, àª¬à«àªà« àªµàªŸàª° àªªà«àª°àª¯àª€à«àªš àªàª°à«.
+FileActions.File_Not_Found_Message:{0}\n àªšàªŸàª®àªšà« àªàªªàª° àª®à«àªàª¬àªšà« àª«àªŸàªàª² àª®àª³à« àª¶àªà« àªšàª¹àª¿. àªàªàªµàªàª€ àª«àªŸàªàª² àªà«àª\n àª€à« àª°à«àª«à«àª°à«àª¶ àª¥àª àªàª, àª¹àªà« àªªàª£ àª«àªŸàªàª² àª
+àªžà«àª€àª¿àª€à«àªµàª®àªŸàª àªà« àª€à«àªšà« àªàªàªŸàªžàª£à« àªàª°à«.
+FileActions.File_Selected:1 àª«àªŸàªàª² àªªàªžàªàªŠ àªàª°à«
+FileActions.Files_And_Directory_Selected:{0} àª«àªŸàªàª²à« àª
+àªšà« 1 àª«à«àª²à«àª¡àª° àªªàªžàªàªŠ àªàª°à«àª¯à«àª
+FileActions.Files_Selected:{0} àª«àªŸàªàª²à« àªªàªžàªàªŠ àªàª°à«
+FileActions.Folder_Already_Exists:'{0}' àªšàªŸàª®àªšà«àª àª«à«àª²à«àª¡àª° àªàªªàª¯à«àªàª®àªŸàª àªà«. àª€à« àª°àªŠ àª¥àª àª¶àªàª¶à« àªšàª¹àª¿.
+FileActions.Insufficient_Space_Message:àª¡àª¿àªžà«àªàª®àªŸàª àª
+àªªà«àª°àª€à« àªàªà«àª¯àªŸ àª¹à«àªµàªŸàªšà« àª²à«àª§à« àª«àªŸàªàª² àªàªà«àª¶àªš àªšàª¿àª·à«àª«àª³ àªàª. àª àª«àªŸàªàª²àªšà« àªžàª«àª³àª€àªŸàªªà«àª°à«àªµàª àªà«àªªà« àªàª°àªµàªŸ àªàª°à«àª°à« àªà«\nàªµàª§àªŸàª°à« : {0}
+FileActions.Moving:{0} àªàª àªàªà«àª¯àªŸàª àª¥à« àª¬à«àªà« àªàªà«àª¯àªŸàª àªàªžà« àª°àª¹à« àªà«
+FileActions.No_Activity:àªà«àª àªªà«àª°àª€àª¿àªà«àª°àª¿àª¯àªŸàªšà« àªàª°à«àª° àªšàª¥à«
+FileActions.Read_Not_Permitted_Message:{0} àªµàªŸàªàªà« àª¶àªà«àª¯àªŸ àªšàª¹àª¿.
+FileActions.File_Permission_Detail:\n\n àªšà«àªàª§: àªžàªŸàª®àªŸàªšà«àª¯ àª°à«àª€à«, àªà«àª°à«àªšàªžà«àªà«àªš àªàª° àª«à«àª²à«àª¡àª° àª®àªŸàªà« àªà«àª°à«àªšàªžà«àªà«àªš àª²àªŸàªàª¬à«àª°à«àª°à« àªàªšà«àªàª°àª«à«àª¶àªšà« àª²àªàªµàªŸàªšà« àªªàª°àªµàªŸàªšàªà« àªàª°à«àª°à« àªà«.Â  \nàªà« {0} àªà«.\n àª¹àªŸàª²àªšàªŸ àªàªªàª­à«àªà«àª€àªŸàªšà« àª àª«à«àª²à«àª¡àª° àª®àªŸàªà« 'àª«à«àª² àªàªàªà«àª°à«àª²' àª®àªàªà«àª° àªàª°à« (àª
+àªšà« àª¬àª§àªŸ àªªà«àªàªŸàª«à«àª²à«àª¡àª°à«àªž)({1}) àª
+àªšà« àª¬à«àªà« àªµàªŸàª° àªªà«àª°àª¯àª€à«àªš àªàª°à«. \n\n (àªµà«àªàª²à«àªªàª¿àª àª°à«àª€à«, àªà«àª°à«àªšàªžà«àªà«àªš àªàªµà« àªàªà«àª¯àªŸàª àª°à«-àªàªšà«àªžà«àªà«àª² àªàª°à« àªà« àªà«àª¯àªŸàª 'àª«à«àª² àªàªàªà«àª°à«àª²'àªàªªàª²àª¬à«àª§ àª¹à«àª¯ àªà«àª® àªà« àª€àª®àªŸàª°àªŸ àªàª° àª«à«àª²à«àª¡àª° àª
+àª¥àªµàªŸ "àª®àªŸàª¯ àª¡à«àªà«àª¯à«àª®à«àªšà«àªà«àªž".)
 
 #************************