Index: documentation/trunk/tutorials/xml-source/tutorial_en.xml
===================================================================
--- documentation/trunk/tutorials/xml-source/tutorial_en.xml	(revision 30227)
+++ documentation/trunk/tutorials/xml-source/tutorial_en.xml	(revision 30229)
@@ -781,5 +781,5 @@
   <Text id="images-gps-1b">When setting folder-level metadata like this, the default setting in GLI is to produce a popup window alerting you to the fact that the assigned metadata will be assigned
   to all files and sub-folders contained in the selected folder.  For this collection, this is what we want, so press <i>OK</i> for the action to proceed.</Text>
-  <Text id="images-gps-1c">Note: if you prefer this popup not to appear each time you assign folder-level metadata, there is a tick-box in the lower left-hand corner of the popup window (&quot;do not show this warning again&quot;) that allows you to control this.  If you choose to supress the popup, then it can be turned back on through <Path>File &rarr; Preferences</Path> and then clicking on the <i>Warnings</i> tab.  The various options are alphabetically sorted, with the option that controls this popup: &quot;About to add folder level metadata&quot;.</Text>
+  <Text id="images-gps-1c">Note: if you prefer this popup not to appear each time you assign folder-level metadata, there is a tick-box in the lower left-hand corner of the popup window (&quot;do not show this warning again&quot;) that allows you to control this.  If you choose to suppress the popup, then it can be turned back on through <Path>File &rarr; Preferences</Path> and then clicking on the <i>Warnings</i> tab.  The various options are alphabetically sorted, with the option that controls this popup: &quot;About to add folder level metadata&quot;.</Text>
 </NumberedItem>
 <NumberedItem>  
@@ -787,5 +787,5 @@
 </NumberedItem>
 <NumberedItem>
-<Text id="images-gps-3">In the <b>Browsing Classifiers</b> section, choose <b>AZCompactList</b> from the <b>select classifier to add</b> dropdown box and press <b>Add Classifier...</b>. In the configuration dialog that appears, set the metadata field to <b>dc.Title</b> and set the buttonname field to <Format>location</Format>. This will create a classifier labelled <Format>location</Format> that groups all images under Eiffel Tower into one bookshelf and similarly creates bookshelves for the other 3 categories.</Text> 
+<Text id="images-gps-3">In the <b>Browsing Classifiers</b> section, choose <b>AZCompactList</b> from the <b>select classifier to add</b> dropdown box and press <b>Add Classifier...</b>. In the configuration dialog that appears, set the metadata field to <b>dc.Title</b> and tick the buttonname option and set its value to <Format>location</Format>. This will create a classifier labelled <Format>location</Format> that groups all images under Eiffel Tower into one bookshelf and similarly creates bookshelves for the other 3 categories.</Text> 
 </NumberedItem>
 <NumberedItem>
@@ -823,5 +823,5 @@
 </NumberedItem>
 <NumberedItem>
-<Text id="images-gps-12">Select <b>Search</b> on the right of the <b>Format</b> panel. For the index on the combined longitude and latitude metadata, type <i>location</i> as its display name.</Text>
+<Text id="images-gps-12">Select <b>Search</b> on the left of the <b>Format</b> panel. For the index on the combined longitude and latitude metadata, type <i>location</i> as its display name.</Text>
 </NumberedItem>
 <NumberedItem>
@@ -838,5 +838,5 @@
   By adding the <Format>&lt;gsf:option name="mapEnabled" value="true" /&gt;</Format> statement
   to the <b>browser</b> format feature, all of the classifiers built will have the map
-  view enabled.  It is also possible to activiate the map view on individual classifiers,
+  view enabled.  It is also possible to activate the map view on individual classifiers,
   and on the search results page by adding the <i>mapEnabled</i> statement to the <i>search</i>
   format feature.
@@ -853,5 +853,5 @@
   </NumberedItem>
   <NumberedItem>
-    <Text id="images-gps-18">Still in the <b>Format</b> panel press the <b>Preview Collection</b> button, browsing or search to locate a document, and then view the document. The page that opens up shows a Google map, shows the location of document (where the photo was taken), in addition to the screen-sized photo.</Text>
+    <Text id="images-gps-18">Still in the <b>Format</b> panel press the <b>Preview Collection</b> button, browse or search to locate a document, and then view the document. The page that opens up shows a Google map, shows the location of the document (where the photo was taken), in addition to the screen-sized photo.</Text>
   </NumberedItem>  
 </Content>