Index: documentation/trunk/wiki/templates/greenstone-monobook/conf/default.php
===================================================================
--- documentation/trunk/wiki/templates/greenstone-monobook/conf/default.php	(revision 30312)
+++ documentation/trunk/wiki/templates/greenstone-monobook/conf/default.php	(revision 30313)
@@ -37,37 +37,37 @@
 
 //user pages
-$conf["monobook_userpage"]    = false; //TRUE: use/show user pages
+$conf["monobook_userpage"]    = 0; //TRUE: use/show user pages
 $conf["monobook_userpage_ns"] = ":wiki:user:"; //namespace to use for user page storage
 
 //discussion pages
-$conf["monobook_discuss"]    = false; //TRUE: use/show discussion pages
+$conf["monobook_discuss"]    = 0; //TRUE: use/show discussion pages
 $conf["monobook_discuss_ns"] = ":talk:"; //namespace to use for discussion page storage
 
 //site notice
-$conf["monobook_sitenotice"]          = true; //TRUE: use/show sitenotice
+$conf["monobook_sitenotice"]          = 1; //TRUE: use/show sitenotice
 $conf["monobook_sitenotice_location"] = ":wiki:site_notice"; //page/article used to store the sitenotice
 
 //navigation
-$conf["monobook_navigation"]           = true; //TRUE: use/show navigation
-$conf["monobook_navigation_location"]  = ":gsdl:wiki:navigation"; //page/article used to store the navigation
-$conf["monobook_navigation_translate"] = true; //TRUE: load translated navigation if translation plugin is available (see <http://www.dokuwiki.org/plugin:translation>)
+$conf["monobook_navigation"]           = 1; //TRUE: use/show navigation
+$conf["monobook_navigation_location"]  = ":wiki:navigation"; //page/article used to store the navigation
+$conf["monobook_navigation_translate"] = 1; //TRUE: load translated navigation if translation plugin is available (see <http://www.dokuwiki.org/plugin:translation>)
 
 //custom copyright notice
-$conf["monobook_copyright"]          = true; //TRUE: use/show copyright notice
-$conf["monobook_copyright_default"]  = false; //TRUE: use default copyright notice (if copyright notice is enabled at all)
-$conf["monobook_copyright_location"] = ":gsdl:wiki:copyright"; //page/article used to store a custom copyright notice
+$conf["monobook_copyright"]          = 1; //TRUE: use/show copyright notice
+$conf["monobook_copyright_default"]  = 0; //TRUE: use default copyright notice (if copyright notice is enabled at all)
+$conf["monobook_copyright_location"] = ":wiki:copyright"; //page/article used to store a custom copyright notice
 
 //search form
-$conf["monobook_search"] = true; //TRUE: use/show search form
+$conf["monobook_search"] = 1; //TRUE: use/show search form
 
 //toolbox
-$conf["monobook_toolbox"]               = true; //TRUE: use/show toolbox
-$conf["monobook_toolbox_default"]       = true; //TRUE: use default toolbox (if toolbox is enabled at all)
-$conf["monobook_toolbox_default_print"] = true; //TRUE: if default toolbox is used, show printable version link?
-$conf["monobook_toolbox_location"]      = ":gsdl:wiki:toolbox"; //page/article used to store a custom toolbox
+$conf["monobook_toolbox"]               = 1; //TRUE: use/show toolbox
+$conf["monobook_toolbox_default"]       = 1; //TRUE: use default toolbox (if toolbox is enabled at all)
+$conf["monobook_toolbox_default_print"] = 1; //TRUE: if default toolbox is used, show printable version link?
+$conf["monobook_toolbox_location"]      = ":wiki:toolbox"; //page/article used to store a custom toolbox
 
 //donation link/button
-$conf["monobook_donate"]          = false; //TRUE: use/show donation link/button
-$conf["monobook_donate_default"]  = false; //TRUE: use default donation link/button (if donation link is enabled at all)
+$conf["monobook_donate"]          = 0; //TRUE: use/show donation link/button
+$conf["monobook_donate_default"]  = 0; //TRUE: use default donation link/button (if donation link is enabled at all)
 $conf["monobook_donate_url"]      = "http://andreas-haerter.com/donate/dokuwiki-template-monobook"; //custom donation URL instead of the default one
 
@@ -86,6 +86,5 @@
 */
 $conf["monobook_cite_author"] = "Contributors of wiki.greenstone.org"; //name to use for the author on the citation page
-$conf["monobook_loaduserjs"]            = false; //TRUE: monobook/user/user.js will be loaded
-$conf["monobook_closedwiki"]            = false; //TRUE: hides most tabs/functions until user is logged in
-
-$conf["monobook_youarehere"] = true;
+$conf["monobook_loaduserjs"]            = 0; //TRUE: monobook/user/user.js will be loaded
+$conf["monobook_closedwiki"]            = 0; //TRUE: hides most tabs/functions until user is logged in
+$conf["monobook_youarehere"] = 1;